---
title: CanvasRenderingContext2D.createRadialGradient()
slug: Web/API/CanvasRenderingContext2D/createRadialGradient
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Gradients
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.createRadialGradient()</code></strong> method of the Canvas 2D API creates a radial gradient using the size and coordinates of two circles.</p>

<p>This method returns a {{domxref("CanvasGradient")}}. To be applied to a shape, the gradient must first be assigned to the {{domxref("CanvasRenderingContext2D.fillStyle", "fillStyle")}} or {{domxref("CanvasRenderingContext2D.strokeStyle", "strokeStyle")}} properties.</p>

<div class="note">
<p><strong>Note:</strong> Gradient coordinates are global, i.e., relative to the current coordinate space. When applied to a shape, the coordinates are NOT relative to the shape's coordinates.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">CanvasGradient <var>ctx</var>.createRadialGradient(<var>x0</var>, <var>y0</var>, <var>r0</var>, <var>x1</var>, <var>y1</var>, <var>r1</var>);
</pre>

<p>The <code>createRadialGradient()</code> method is specified by six parameters, three defining the gradient's start circle, and three defining the end circle.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x0</code></dt>
 <dd>The x-axis coordinate of the start circle.</dd>
 <dt><code>y0</code></dt>
 <dd>The y-axis coordinate of the start circle.</dd>
 <dt><code>r0</code></dt>
 <dd>The radius of the start circle. Must be non-negative and finite.</dd>
 <dt><code>x1</code></dt>
 <dd>The x-axis coordinate of the end circle.</dd>
 <dt><code>y1</code></dt>
 <dd>The y-axis coordinate of the end circle.</dd>
 <dt><code>r1</code></dt>
 <dd>The radius of the end circle. Must be non-negative and finite.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<dl>
 <dt>{{domxref("CanvasGradient")}}</dt>
 <dd>A radial <code>CanvasGradient</code> initialized with the two specified circles.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Filling_a_rectangle_with_a_radial_gradient">Filling a rectangle with a radial gradient</h3>

<p>This example initializes a radial gradient using the <code>createRadialGradient()</code> method. Three color stops between the gradient's two circles are then created. Finally, the gradient is assigned to the canvas context, and is rendered to a filled rectangle.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas" width="200" height="200"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[7]">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

// Create a radial gradient
// The inner circle is at x=110, y=90, with radius=30
// The outer circle is at x=100, y=100, with radius=70
var gradient = ctx.createRadialGradient(110,90,30, 100,100,70);

// Add three color stops
gradient.addColorStop(0, 'pink');
gradient.addColorStop(.9, 'white');
gradient.addColorStop(1, 'green');

// Set the fill style and draw a rectangle
ctx.fillStyle = gradient;
ctx.fillRect(20, 20, 160, 160);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Filling_a_rectangle_with_a_radial_gradient', 700, 240) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-createradialgradient", "CanvasRenderingContext2D.createRadialGradient")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.createRadialGradient")}}</p>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>Starting with Gecko 2.0 {{geckoRelease("2.0")}}, specifying non-finite values now throws <code>NOT_SUPPORTED_ERR</code> instead of <code>SYNTAX_ERR</code>.</li>
 <li>Starting with Gecko 5.0 {{geckoRelease("5.0")}}, specifying a negative radius correctly throws <code>INDEX_SIZE_ERR</code>.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.createLinearGradient()")}}</li>
</ul>
